<!DOCTYPE html>
<html lang="de">
<head>
  <meta charset="UTF-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
<!--
  <link href="https://cdn.jsdelivr.net/npm/bootstrap@5.3.1/dist/css/bootstrap.min.css" rel="stylesheet"
    integrity="sha384-4bw+/aepP/YC94hEpVNVgiZdgIC5+VKNBQNGCHeKRQN+PtmoHDEXuppvnDJzQIu9" crossorigin="anonymous">
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.3.1/dist/js/bootstrap.bundle.min.js"
    integrity="sha384-HwwvtgBNo3bZJJLYd8oVXjrBZt8cqVSpeBNS5n7C8IVInixGAoxmnlMuBnhbgrkm"
    crossorigin="anonymous"></script>
  <script src="https://code.jquery.com/jquery-3.7.1.min.js"
    integrity="sha256-/JqT3SQfawRcv/BIHPThkBvs0OEvtFFmqPF/lYI/Cxo=" crossorigin="anonymous"></script>
    <script src="https://cdn.datatables.net/1.13.6/js/jquery.dataTables.min.js" integrity="sha384-k5vbMeKHbxEZ0AEBTSdR7UjAgWCcUfrS8c0c5b2AfIh7olfhNkyCZYwOfzOQhauK" crossorigin="anonymous"></script>
-->

  {% load static %}
  <link rel="shortcut icon" type="image/png" href="{% static 'images/favicon.ico' %}" >
  <link href="{% static 'script/bootstrap.min.css' %}" rel="stylesheet">
  <script src="{% static 'script/bootstrap.bundle.min.js' %}"></script>
  <script src="{% static 'script/jquery-3.7.1.min.js' %}"></script>
  <script src="{% static 'script/jquery.dataTables.min.js' %}"></script>

  <title>Vergleichsresultat</title>

  <style>
    body {
        font-family: Arial, sans-serif;
        margin: 0;
    }
    form {
        background-color: #F4F5DB;
        border-bottom: 1px solid #000;
    }
    .form-container {
        max-width: 790px;
        padding: 30px;
        margin: 0 auto;
    }
    .form-group {
        margin-bottom: 10px;
    }
    .error-div {
        background-color: yellow;
        padding-left: 30px;
        padding-right: 30px;
        color: red;
        position: fixed;
        z-index: 1501;
        width: 100%;
        overflow:scroll;
        max-width:98%;
        max-height:85%
    }
    #askForOperationDiv {
        position: fixed;
        background-color: aquamarine;
    }
    th, td {
        padding-left: 20px;
        width: 30%;
        text-align: center;
    }
    td {
        cursor: pointer;
    }
    label {
        display: block;
        margin-bottom: 5px;
    }
    input[type="file"] {
        width: 100%;
        padding: 5px;
    }
    button[type="submit"] {
        background-color: #6c757d;
        color: #fff;
        border: none;
        padding: 10px 20px;
        border-radius: 5px;
        cursor: pointer;
    }
    button[type="submit"]:hover {
        background-color: #6c757d;
    }
    #error-div, #askForOperationDiv, #prg1_upload {
        margin: 10px;
        padding: 20px;
        border: 1px solid #ccc;
        border-radius: 10px;
        background-color: #f5f5f5;
        z-index: 1;
    }
    .headline {
        text-align: center;
        margin-bottom: 20px;
    }
    #btnUpload {
        margin: auto;
        border: 1px solid #000;
        border-left: none;
    }
    #fileInput1 {
        padding: 6px 12px;
        border: 1px solid #000;
    }
    .selected-databases {
        padding: 20px;
        display: flex;
        flex-direction: column;
        justify-content: center;
        align-items: center;
        background-color: #f5f5f5;
        border-bottom: 1px solid #000;
    }
    .top-database-container {
        display: flex;
        flex-direction: row;
        justify-content: space-around;
        align-items: center;
        width: 100%;
        margin-bottom: 20px;
    }
    .bottom-database-container {
        width: 450px;
        display: flex;
        justify-content: space-between;
    }
    .form-control:focus {
        outline: 0;
        border: none;
        box-shadow: none;
    }
    .table-striped>tbody>tr:nth-of-type(odd)>* {
        --bs-table-bg-type: #F4F5DB;
    }
    #fileList {
        padding: 20px;
    }
  </style>
</head>
<body>
    <div id="error-div" class="error-div" style="display: none;">
        <div id="err-text"></div>
        <button id="btnCloseError" type="button" class="btn btn-secondary btn-lg">Close</button>
    </div>
    <div id="askForOperationDiv" style="display: none;">
        <label>What to do with <label id="lblFilename"></label>?</label>
        <button id="btnSetLeft" type="button" class="btn btn-secondary btn-lg" title="Als linker Datenbank festlegen">&#9636;&#8678;</button>
        <button id="btnSetRight" type="button" class="btn btn-secondary btn-lg" title="Als rechter Datenbank festlegen">&#8680;&#9636;</button>
        <a id="downloadLink"><button type="button" class="btn btn-secondary btn-lg" title="Datei runterladen">Download</button></a>
        <button id="btnCancelOperation" type="button" class="btn btn-secondary btn-lg" title="Abbrechen">Cancel</button>
        <button id="btnDelete" type="button" class="btn btn-danger btn-lg" title="Datei vom Server entfernen">Delete</button>
    </div>
    <progress id="prg1_upload" value="0" max="100" style="display: none;"></progress>
    <form id="fileForm" enctype="multipart/form-data" method="post">
        {% csrf_token %}
        <div class="form-container">
            <h3 class="headline">Wählen Sie die Datenbanken Ihrer Wahl aus und starten Sie ein spannendes Vergleichsabenteuer!</h3>
            <div class="input-group">
                <input type="file" class="form-control" id="fileInput1" name="fileInput1" accept=".sqlite3">
                <label id="btnUpload" class="input-group-text" for="fileInput1">&#8682;</label>
            </div>
        </div>
    </form>
    <div class="selected-databases">
        <h5 class="headline">Ausgewählte Datenbanken</h5>
        <div class="top-database-container">
            <div>
                <span><strong>Left: </strong></span>
                <span id="leftDb"></span>
            </div>
            <div>
                <span><strong>Right: </strong></span>
                <span id="rightDb"></span>
            </div>
        </div>
        <div class="bottom-database-container">
            <button id="btnSwitch" type="button" class="btn btn-secondary btn-lg" style="display: none;">Seiten wechseln &#9636;&#8644;&#9636;</button>
            <a href="/compare/"><button id="btnCompare" type="button" class="btn btn-primary btn-lg">Zum Vergleich! &#10132;</button></a>
        </div>
    </div>
    <div id="fileList">
        <h5 class="headline">Hochgeladene Datenbanken</h5>
        <table class='table table-hover table-striped'>
            <thead>
                <tr>
                {% for th in filelist_header %}
                <th>{{th}}</th>
                {% endfor %}
                </tr>
            </thead>
            <tbody>
                {% for tr in filelist_rows %}
                <tr data-filename="{{tr.0}}">
                    {% for td in tr %}
                    <td>{{td}}</td>
                    {% endfor %}
                </tr>
                {% endfor %}
            </tbody>
        </table>
    </div>


    <script>
    if (typeof jQuery == "undefined") alert("jQuery not loaded. the website can't work without it. you have to make sure that you are connected to the internet or you have to download and link the needed files e.g. jQuery and bootstrap locally");
    $(document).ready(function(){
        $.ajaxSetup({
            beforeSend: function(xhr, settings) {
                xhr.setRequestHeader("X-CSRFToken", $('input[name="csrfmiddlewaretoken"]').attr('value'));
            }
        });

        $('#btnUpload').click(function(){
            upload_file();
        });
        $('#fileInput1').change(function() {
            $('#fileForm').submit();
        });
        $('#btnCloseError').click(()=>{
            var errorDiv = $('#error-div');
            errorDiv.hide();
            errorDiv.find('#err-text').empty();
        });
        $('tbody > tr').click(function(event){
            $('#downloadLink, #btnDelete').show();
            askForOperation($(this).data('filename'), event);
        });
        $('#btnSetLeft').click(function(){
            localStorage['leftDb'] = currentFilename;
            loadLocalStorage();
            $('#askForOperationDiv').hide();
        });
        $('#btnSetRight').click(function(){
            localStorage['rightDb'] = currentFilename;
            loadLocalStorage();
            $('#askForOperationDiv').hide();
        });
        $('#btnDelete').click(function(){
            var yesDelete = confirm('delete ' + currentFilename + '?');
            if (yesDelete) {
                post('jqp_delete_file',{'path' : currentFilename}, (res) => {
                    if (localStorage['leftDb'] == currentFilename) localStorage.removeItem('leftDb');
                    if (localStorage['rightDb'] == currentFilename) localStorage.removeItem('rightDb');

                    // location.reload(true);
                    location.href = location.href
                });
            }
        });
        $('#btnSwitch').click(function(){
            var tmp = localStorage['leftDb'];
            localStorage['leftDb'] = localStorage['rightDb']
            localStorage['rightDb'] = tmp;
            loadLocalStorage();
        });
         $('#btnCompare').click(function(){
            var left = localStorage['leftDb'];
            var right = localStorage['rightDb'];
            if (left == null || right == null){
                if (left == null && right == null){
                    alert("Sie müssen zuerst die rechte und die linke Datenbanken festlegen!");
                }
                else if (left == null){
                    alert("Sie haben nur die rechte Datenbank festgelegt. Sie müssen noch die linke Datenbank festlegen!");
                }
                else {
                    alert("Sie haben nur die linke Datenbank festgelegt. Sie müssen noch die rechte Datenbank festlegen!");
                }
                var trs = $('tbody > tr');
                if (trs.length > 1){
                    trs.fadeToggle();
                    trs.fadeToggle();
                }
                else {
                    var fileInput = $('#fileInput1');
                    fileInput.fadeToggle();
                    fileInput.fadeToggle();
                }
                return false;
            }
            else if(left == right) alert('Vorsicht, Sie haben die selbe Datei auf beiden Seiten festgelegt!! Das macht wenig Sinn :) . Im Ergebnis können Sie sehen, welche Datensätzen nicht über papers erreichbar sind.');
        });
       $('#btnCancelOperation').click(function(){
            $('#askForOperationDiv').hide();
        });
        $(document).on('keyup', function(e) {
          if (e.key == "Escape") $('#askForOperationDiv').hide();
        });
        loadLocalStorage();


        var uploadedFile = "{{uploadedFile}}";
        if (uploadedFile == "null") uploadedFile = null;
        if (uploadedFile != null){
            $('#downloadLink, #btnDelete').hide();
            askForOperation(uploadedFile, undefined)
        }

        var currentFilename;
        function askForOperation(filename, event){
            currentFilename = filename;
            div = $('#askForOperationDiv');
            div.find('#lblFilename').text(filename);
            div.find('#downloadLink').attr('href', 'download/' + filename);

            if (event) {
                const mouseX = event.clientX;
                const mouseY = event.clientY;

                if (mouseX + 478.8 > window.innerWidth) {
                    div[0].style.left = (mouseX - 478.8) + 'px';
                } else {
                    div[0].style.left = mouseX + 'px';
                }

                if (mouseY + 172 > window.innerHeight) {
                    div[0].style.top = (mouseY - 172) + 'px';
                } else {
                    div[0].style.top = mouseY + 'px';
                }
            } else {
                div[0].style.left = 'calc(50% - 239px)'
            }

            div.show();
        }
        function upload_file(){
            // var leftValue = document.getElementById('fileInput1').files[0];
            // var rightValue = document.getElementById('fileInput2').files[0];

            $.ajax({
                url: '',
                type: 'POST',
                data: new FormData($('form')[0]),
                cache: false,
                contentType: false,
                processData: false,
                xhr: function () {
                    var myXhr = $.ajaxSettings.xhr();
                    if (myXhr.upload) {
                        myXhr.upload.addEventListener('progress', function (e) {
                            if (e.lengthComputable) {
                                $('#prg1_upload').attr({
                                value: e.loaded,
                                max: e.total,
                                });
                            }
                        }, false);
                    }
                    return myXhr;
                }
            });
        }
        function post(jqp_function, parameterObj, callback_function){
            if (!jqp_function.startsWith('jqp_')){
                debugger;
            }

            jsonObj = {'jqp_function' : jqp_function};
            $.extend(jsonObj, parameterObj);
            var jqxhr = $.post("", jsonObj, function(data) {
                // console.log(data);
                if (callback_function != null) callback_function(data);
            })
            .fail(function(resp) {
                if (typeof resp.responseText != "undefined")
                    alertError(resp.responseText);
                else{
                    alertError('error while contacting the server');
                }
            });
        }
        function alertError(msg){
            var errorDiv = $('#error-div');
            var newInnerDiv = $('<div>').append(msg);
            errorDiv.find('#err-text').append(newInnerDiv);
            errorDiv.show();
            // console.log(msg);
            // $('html').html(msg);
        }

        function loadLocalStorage(){
            $('#leftDb').text(localStorage['leftDb']);
            $('#rightDb').text(localStorage['rightDb']);
            if (localStorage['leftDb'] != null && localStorage['rightDb'] != null){
                $('#btnSwitch').show();
                $('#toComparePage').show();
            }
        }

        if(typeof DataTable != "undefined"){
            $("#fileList").find('table').each(function(){
                new DataTable(this, {'searching': false, "bPaginate": false, info: false, scrollCollapse: true,scrollY: '250px', "scrollX": true, "autoWidth": false , "oLanguage": {"sSearch": ""}});
            });

            $('input[type="search"]').prop('placeholder', 'search...')
        }


    });
    </script>
</body>
</html>